'From Squeak3.8.1 of ''28 Aug 2006'' [latest update: #6747] on 16 June 2008 at 1:54:42 pm'!

!SequenceableCollection methodsFor: '*REPLMorph' stamp: 'spfa 10/3/2006 10:29'!
lastIndexOfSubCollection: sub ifAbsent: exceptionBlock
	"Answer the index of the receiver's last element, such that that element 
	equals the first element of sub, and the next elements equal 
	the rest of the elements of sub. Begin the search at element 
	end of the receiver. If no such match is found, answer the result of 
	evaluating argument, exceptionBlock."
	| first index |
	sub isEmpty ifTrue: [^ exceptionBlock value].
	first _ sub first.
	self size - sub size + 1 to: 1 by: -1 do:
		[:startIndex |
		(self at: startIndex) = first ifTrue:
			[index _ 1.
			[(self at: startIndex+index-1) = (sub at: index)]
				whileTrue:
				[index = sub size ifTrue: [^startIndex].
				index _ index+1]]].
	^ exceptionBlock value! !
