Prolog subclass: #FisherTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!
!FisherTutorial commentStamp: '<historical>' prior: 0!
This class and its subclasses implements code from the on-line Prolog tutorial at:
http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/contents.html!



FisherTutorial subclass: #Chapter2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

!Chapter2 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 10:59'!
logicFactorial

factorial(0,1). 

factorial(n,f) :-  
   gt(n,0), 
   is(n1, n - 1), 
   factorial(n1,f1), 
   is(f, n * f1).! !

!Chapter2 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 11:15'!
logicFactorialT

factorialT(0,f,f). 

factorialT(n,a,f) :-  
    gt(n,0), 
    is(a1, n* a), 
    is(n1, n - 1), 
    factorialT(n1,a1,f).! !

!Chapter2 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 12:30'!
logicMember

member(x,[x|_]).
member(x,[_|r]) :- member(x,r).! !

!Chapter2 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 12:34'!
logicTakeout

takeout(x,[x|r],r).
takeout(x,[f|r],[f|s]) :- takeout(x,r,s).! !


FisherTutorial subclass: #Chapter3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 10:48'!
logicBlack

black(#b).                           
 ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 10:50'!
logicColor

color(p,'red') :- red(p),!!.
color(p,'black') :- black(p),!!.
color(p,'unknown').                            
 ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 10:43'!
logicP

p(#a).                        
p(x) :- q(x), r(x).            
p(x) :- u(x).  ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 09:45'!
logicQ

q(x) :- s(x). ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 10:43'!
logicR

r(#a).                          
r(#b).                            
 ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 10:48'!
logicRed

red(#a).                           
 ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 10:43'!
logicS

s(#a).      
s(#b).          
s(#c).                           
 ! !

!Chapter3 methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 10:43'!
logicU

u(#d).                           
 ! !
